/*****************************************************************************
 *
 *  AngleParameter.h                            XMM Science Analysis Subsystem
 *
 *  Angle task parameter
 *
 *  (c) 1999  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: AngleParameter.h,v 1.5 2002/12/17 17:53:48 jbakker Exp $
 *
 *****************************************************************************/

#ifndef ANGLEPARAMETER_H
#define ANGLEPARAMETER_H

#include "RealParameter.h"
#include "AngleFormatter.h"

#include <string>


//================================================================
//  Class AngleParameter
//================================================================

class AngleParameter : public RealParameter
{
public:

    // Construction
    AngleParameter* clone() { return new AngleParameter(*this); }
    AngleParameter();

    // Value
    ParamType   getType() const {return Parameter::Angle;}
    const char* getTypeName() const { return "angle"; }

    // Formatting
    std::string      asString() const;
    std::string      defaultAsString() const;
    AngleFormatter::AngleMode getMode() const { return _mode; }
    void setMode(AngleFormatter::AngleMode mode);

private:

    // Parsing
    bool parse(const std::string& str, double& value);

    // Member data
    AngleFormatter::AngleMode _mode;
};

#endif
