// -*-C++-*-
//
// File:      ParamParser.h
// Author:    Jorgo Bakker (jbakker@rssd.esa.int)
// Generated: Mon Feb 10 12:28:59 CET 2003
// Usage:     -
// Info:      -

#ifndef ParamParser_h
#define ParamParser_h

#include <string>
class ParameterInfo;

/**
 * ParamParser is the abstract interface of all Parameter parsers.
 */
class ParamParser 
{
  
public:
  ParamParser(){}
  virtual ~ParamParser(){}
  
  /**
   * Loads the parameters from specified file
   * @param  nameOfFile specified name of file
   * @return            the collection of parameters found in the file.
   */
  virtual ParameterInfo* load(const std::string& nameOfFile)=0;

  /**
   * Saves the parameters to specified file
   * @param nameOfFile specified name of file
   * @param info       the collection of parameters ready for saving.
   */
  virtual void save(const ParameterInfo& info,const std::string& nameOfFile)=0;

private:
  ParamParser(const ParamParser&);      // copy constructor disabled!
  ParamParser& operator=(const ParamParser&); // assignment disabled!
};



#endif
