/*****************************************************************************
 *
 *  StringToken.h                               XMM Science Analysis Subsystem
 *
 *  Token class
 *
 *  (c) 1998  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: StringToken.h,v 1.4 2002/12/17 17:53:50 jbakker Exp $
 *
 *****************************************************************************/

#ifndef STRINGTOKEN_H
#define STRINGTOKEN_H

#include <iostream>           // C++ headers
#include <string>


//================================================================
//  Class StringToken
//================================================================

class StringToken
{
public:
    StringToken(const std::string& s) : _s(s), _valid(true) {}

    int           asInt();
    double        asDouble();
    const std::string& asString() { return _s; }
    std::string        asUnquotedString();
    bool          asBool();
    bool          isValid() const { return _valid; }
    bool          isUndef() const;

    friend std::ostream& operator<<(std::ostream& os, const StringToken& t);

private:
    std::string _s;
    bool   _valid;
};

#endif
