/*****************************************************************************
 *
 *  TimeParameter.h                            XMM Science Analysis Subsystem
 *
 *  Time task parameter
 *
 *  (c) 1999  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: TimeParameter.h,v 1.6 2002/12/17 17:53:51 jbakker Exp $
 *
 *****************************************************************************/

#ifndef TIMEPARAMETER_H
#define TIMEPARAMETER_H

#include "RealParameter.h"
#include "TimeFormatter.h"

#include <string>


//================================================================
//  Class TimeParameter
//================================================================

class TimeParameter : public RealParameter
{
public:

    // Construction
    TimeParameter* clone() { return new TimeParameter(*this); }
    TimeParameter();

    // Value
    ParamType   getType() const { return Parameter::Time; }
    const char* getTypeName() const { return "time"; }

    // Formatting
    std::string      asString() const;
    std::string      defaultAsString() const;
    TimeFormatter::TimeMode getMode() const { return _mode; }
    void setMode(TimeFormatter::TimeMode mode);

private:

    // Parsing
    bool parse(const std::string& str, double& value);

    // Member data
    TimeFormatter::TimeMode _mode;
};

#endif
