// -*-C++-*-
//
// File:      XmlInfoReader.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Mon Nov 26 15:36:30 MET 2001

#include "XmlInfoReader.h"
#include "XmlParamParser.h"
#include "ParameterInfo.h"
#include <errstr.h>
#include <SasFileLocator.h>

XmlInfoReader::XmlInfoReader(const std::string& name,bool isTaskName)
{
  _info = 0;
  std::string parFile;
  if (isTaskName) {
      std::string parName("config/" + name + ".par");
      SasFileLocator locator("");
      parFile = locator.locate(parName, "", false);

      if (parFile.empty())
	errstr << "Could not find parameter file '"
	       << parName << "' in SAS_PATH or SAS_DIR"
	       << Sas::error("ParamFileOpen");
  }
  else {
    parFile=name;
  }

  // This replaces old code
  XmlParamParser parser;
  _info=parser.load(parFile);

  if (_info) _info->setTaskName(isTaskName?name:parFile);
}

XmlInfoReader::~XmlInfoReader()
{
}

ParameterInfo* XmlInfoReader::getParamInfo()
{
  return _info;   // Null pointer if error
}
