/****************************************************************************
 *
 *  testsetparam.cc                            XMM Science Analysis Subsystem
 *
 *  Test setting of parameters by task
 *
 *  (c) 1998  ESA  -  Written by Jon Brumfitt, Aurora
 *
 *  $Id: testcloseparam.cc,v 1.4 2003/06/16 08:42:44 gvacanti Exp $
 *
 *****************************************************************************/

#include <Parameter.h>               // Application headers
#include <param.h>
#include<cassert>

#include <cmath>                    // C headers

#include <iostream>                // C++ headers
#include <string>
#include <vector>

#include <errstr.h>

void dump()
{
  // Print current values of parameters
  std::cout << *gParameters;
}

int main()
{
    // init
    openParameters("testcloseparam");
    bool orig=booleanParameter("bool");
    
    // change it, and test its state
    setParameter("bool", !orig);
    assert(booleanParameter("bool") != orig);
    

    // test,whether the state is remembered
    openParameters("testcloseparam");
    assert(booleanParameter("bool") != orig);
    
    // test, whether close actually resets its state
    closeParameters();
    openParameters("testcloseparam");
    assert(booleanParameter("bool") == orig);
    
    return 0;
}
